<template>
  <div class="system-add-user-container">
    <el-dialog :title="title" v-model="isShowDialog" width="50%">
      <el-form :model="form" size="default" ref="formRef" :rules="rules" label-width="200px">
        <el-row :gutter="35">
          <el-col :xs="24" :sm="24" :md="24" :lg="24" :xl="24" class="mb20">
            <el-form-item label="从业人数" prop="cyrs">
              <el-input v-model.trim.number="form.cyrs" placeholder="从业人数" type="number" clearable></el-input>
            </el-form-item>
          </el-col>
          <el-col :xs="24" :sm="24" :md="24" :lg="24" :xl="24" class="mb20">
            <el-form-item label="主要负责人" prop="zyfzr">
              <el-input v-model.trim="form.zyfzr" placeholder="主要负责人" clearable></el-input>
            </el-form-item>
          </el-col>
          <el-col :xs="24" :sm="24" :md="24" :lg="24" :xl="24" class="mb20">
            <el-form-item label="安全负责人" prop="aqfzr">
              <el-input v-model.trim="form.aqfzr" placeholder="安全负责人" clearable></el-input>
            </el-form-item>
          </el-col>
          <el-col :xs="24" :sm="24" :md="24" :lg="24" :xl="24" class="mb20">
            <el-form-item label="生产/经营地址" prop="scjydz">
              <el-input v-model.trim="form.scjydz" :autosize="{ minRows: 1 }" type="textarea" placeholder="生产/经营地址" clearable></el-input>
            </el-form-item>
          </el-col>
          <el-col :xs="24" :sm="24" :md="24" :lg="24" :xl="24" class="mb20">
            <el-form-item label="特殊作业人数" prop="specialNum">
              <el-input v-model.trim.number="form.specialNum" placeholder="特殊作业人数" type="number" clearable></el-input>
            </el-form-item>
          </el-col>
          <el-col :xs="24" :sm="24" :md="24" :lg="24" :xl="24" class="mb20">
            <el-form-item label="特殊作业证书到期人数" prop="specialCertExpireNum">
              <el-input v-model.trim.number="form.specialCertExpireNum" placeholder="特殊作业证书到期人数" type="number" clearable></el-input>
            </el-form-item>
          </el-col>
          <el-col :xs="24" :sm="24" :md="24" :lg="24" :xl="24" class="mb20">
            <el-form-item label="专职安全人员人数" prop="proSafeNum">
              <el-input v-model.trim.number="form.proSafeNum" placeholder="专职安全人员人数" type="number" clearable></el-input>
            </el-form-item>
          </el-col>
          <el-col :xs="24" :sm="24" :md="24" :lg="24" :xl="24" class="mb20">
            <el-form-item label="专职安全人员证书到期人数" prop="proSafeCertExpireNum">
              <el-input v-model.trim.number="form.proSafeCertExpireNum" placeholder="专职安全人员证书到期人数" type="number" clearable></el-input>
            </el-form-item>
          </el-col>
          <el-col :xs="24" :sm="24" :md="24" :lg="24" :xl="24" class="mb20">
            <el-form-item label="专职安全人员复审培训到期人数" prop="proSafeCheckTrainExpireNum">
              <el-input v-model.trim.number="form.proSafeCheckTrainExpireNum" placeholder="专职安全人员复审培训到期人数" type="number" clearable></el-input>
            </el-form-item>
          </el-col>
          <el-col :xs="24" :sm="24" :md="24" :lg="24" :xl="24" class="mb20">
            <el-form-item label="注册安全工程师人数" prop="registSafeNum">
              <el-input v-model.trim.number="form.registSafeNum" placeholder="注册安全工程师人数" type="number" clearable></el-input>
            </el-form-item>
          </el-col>
          <el-col :xs="24" :sm="24" :md="24" :lg="24" :xl="24" class="mb20">
            <el-form-item label="注册安全工程师证书到期人数" prop="registSafeCertExpireNum">
              <el-input v-model.trim.number="form.registSafeCertExpireNum" placeholder="注册安全工程师证书到期人数" type="number" clearable></el-input>
            </el-form-item>
          </el-col>
          <el-col :xs="24" :sm="24" :md="24" :lg="24" :xl="24" class="mb20">
            <el-form-item label="注册安全工程师复审培训到期人数" prop="registSafeCheckTrainExpireNum">
              <el-input v-model.trim.number="form.registSafeCheckTrainExpireNum" placeholder="注册安全工程师复审培训到期人数" type="number" clearable></el-input>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <template #footer>
        <span class="dialog-footer">
            <el-button @click="isShowDialog = !isShowDialog" size="default">取 消</el-button>
            <el-button type="primary" v-throttle @click="onSubmit" size="default">确 定</el-button>
        </span>
      </template>
    </el-dialog>
  </div>
</template>

<script lang="ts">
import { reactive, toRefs, onMounted, defineComponent, ref } from 'vue';
import { ElMessageBox, ElMessage } from 'element-plus';
import axios from "axios";
import {workApplyApi} from "/@/api/specialWorkSystem/workApply";
import {judgeReportApi} from "/@/api/dataUpload/saftyBaseInfo/judgeReport";

// 定义接口来定义对象的类型
interface DataState {
  title: string
  isShowDialog: boolean
  form: {
    cyrs: number | null
    zyfzr: string
    aqfzr: string
    scjydz: string
    specialNum: number | null
    specialCertExpireNum: number | null
    proSafeNum: number | null
    proSafeCertExpireNum: number | null
    proSafeCheckTrainExpireNum: number | null
    registSafeNum: number | null
    registSafeCertExpireNum: number | null
    registSafeCheckTrainExpireNum: number | null
  }
  rules:{}
}

export default defineComponent({
  name: 'reportDialog',
  setup(props, context) {
    const formRef = ref()
    const state = reactive<DataState>({
      title: '',
      isShowDialog: false,
      form: {
        cyrs: null,
        zyfzr: '',
        aqfzr: '',
        scjydz: '',
        specialNum: null,
        specialCertExpireNum: null,
        proSafeNum: null,
        proSafeCertExpireNum: null,
        proSafeCheckTrainExpireNum: null,
        registSafeNum: null,
        registSafeCertExpireNum: null,
        registSafeCheckTrainExpireNum: null
      },
      rules:{
        cyrs: [{ required: true, message: '请填写从业人数', trigger: 'blur' }],
        zyfzr: [{ required: true, message: '请填写主要负责人', trigger: 'blur' }],
        aqfzr: [{ required: true, message: '请填写安全负责人', trigger: 'blur' }],
        scjydz: [{ required: true, message: '请填写生产/经营地址', trigger: 'blur' }],
        specialNum: [{ required: true, message: '请填写特殊作业人数', trigger: 'blur' }],
        specialCertExpireNum: [{ required: true, message: '请填写特殊作业证书到期人数', trigger: 'blur' }],
        proSafeNum: [{ required: true, message: '请填写专职安全人员人数', trigger: 'blur' }],
        proSafeCertExpireNum: [{ required: true, message: '请填写专职安全人员证书到期人数', trigger: 'blur' }],
        proSafeCheckTrainExpireNum: [{ required: true, message: '请填写专职安全人员复审培训到期人数', trigger: 'blur' }],
        registSafeNum: [{ required: true, message: '请填写注册安全工程师人数', trigger: 'blur' }],
        registSafeCertExpireNum: [{ required: true, message: '请填写注册安全工程师证书到期人数', trigger: 'blur' }],
        registSafeCheckTrainExpireNum: [{ required: true, message: '请填写注册安全工程师复审培训到期人数', trigger: 'blur' }]
      }
    })

    // 页面加载时
    onMounted(() => {

    })
    // 打开弹窗
    const open = (type: string, data: object) => {
      state.isShowDialog = true;
      if (type === 'add') {
        state.title = '新增上报';
        state.form = {
          cyrs: null,
          zyfzr: '',
          aqfzr: '',
          scjydz: '',
          specialNum: null,
          specialCertExpireNum: null,
          proSafeNum: null,
          proSafeCertExpireNum: null,
          proSafeCheckTrainExpireNum: null,
          registSafeNum: null,
          registSafeCertExpireNum: null,
          registSafeCheckTrainExpireNum: null
        };
      }
    };

    // 新增修改
    const onSubmit = async () => {
      formRef.value.validate(async (valid:Boolean) => {
        if(valid){
          const res = await judgeReportApi().addCrow(state.form)
          if(res.data.code == 200){
            ElMessage({
              type:'success',
              message:'数据上报成功'
            })
            state.isShowDialog = false
          }else{
            ElMessage({
              type:'warning',
              message:res.data.msg
            })
          }
          context.emit('refresh')
        }else{
          ElMessage({
            type:'warning',
            message:'请完善基本信息'
          })
        }
      })
    }


    return {
      formRef,
      open,
      onSubmit,
      ...toRefs(state)
    };
  }
});
</script>
